> ## Documentation Index
> Fetch the complete documentation index at: https://telnesstech-a0a16404.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create user

> Create a new user.



## OpenAPI

````yaml /api-reference/bundled_openapi.json post /users
openapi: 3.1.0
info:
  title: Telness Tech Connect
  version: 2.0.0-alpha
  description: >
    Telness Tech Connect API provides all you need to own your user's
    connectivity experience.


    Go back to [Telnesstech.com](https://telnesstech.com)
servers:
  - url: https://apiv2.example.com
    description: Connect API URL for your domain
security:
  - apiKey: []
  - bearerAuth: []
    apiKey: []
tags:
  - name: Auth
    description: Authenticate users and obtain access tokens.
  - name: Users
    description: Manage users.
  - name: Customers
    description: Manage customers.
  - name: Subscriptions
    description: Manage subscriptions and subscription.
  - name: Subscription Addons
    description: Manage subscription addons.
  - name: Subscription Usage
    description: Get subscription usage.
  - name: Subscribers
    description: Manage subscribers.
  - name: Licenses
    description: Manage licenses.
  - name: Product Offerings
    description: Browse product offerings.
  - name: Product Catalogs
    description: Browse product catalogs.
  - name: Product Discounts
    description: Discounts and promotions.
  - name: Orders
    description: Manage orders and line items.
  - name: Payment Intents
    description: >-
      Inspect payment intents, the money collected over card rails for orders
      and renewals.
  - name: Payment Links
    description: Create and manage payment links for orders and invoices.
  - name: Payment Sessions
    description: Create and manage payment sessions for orders.
  - name: Payment Profiles
    description: Manage customer payment profiles and methods.
  - name: Payment Profile Sessions
    description: Create sessions for setting up payment profiles.
  - name: Signing sessions
    description: Handle contract signing sessions for postpaid orders.
  - name: Porting
    description: Manage number porting for subscriptions.
  - name: Taxes
    description: Calculate taxes for products and line items.
  - name: Invoices
    description: Manage invoices and invoice items.
  - name: Tools
    description: >-
      Tools for address validation, number porting, device info, and network
      coverage.
  - name: Inventory
    description: Manage phone number inventory, SIM cards, and reservations.
  - name: Workflows
    description: Dynamic processing of customer journeys and events.
paths:
  /users:
    post:
      tags:
        - Users
      summary: Create user
      description: Create a new user.
      operationId: createUser
      parameters:
        - $ref: '#/components/parameters/IdempotencyKey'
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateUserRequest'
      responses:
        '201':
          description: User created successfully.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/User'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '409':
          $ref: '#/components/responses/Conflict'
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  parameters:
    IdempotencyKey:
      in: header
      name: X-Idempotency-Key
      required: false
      description: >
        A unique key to ensure idempotency of requests. If a request with the
        same key has already been processed, the same result will be returned.

        The key must be unique for each distinct operation. Keys are expired
        after 24 hours, but we recommend using a new key for each request.


        Modified requests with the same idempotency keys are rejected with a
        `409 Conflict` status code.
      schema:
        type: string
        maxLength: 256
  schemas:
    CreateUserRequest:
      type: object
      description: Request to create a user.
      required:
        - name
        - email
        - customerId
      additionalProperties: false
      properties:
        name:
          type: string
          description: Name of the user.
          example: John Doe
        email:
          type: string
          format: email
          description: Email of the user.
          example: john.doe@example.com
        msisdn:
          type: string
          format: phone
          description: Mobile phone number of the user.
          example: '+15551234567'
        role:
          type: string
          enum:
            - MEMBER
            - MANAGER
            - ADMIN
          default: MEMBER
          description: >-
            The role of the user when assigned to a customer. Defaults to
            'MEMBER' if not specified.
        customerId:
          type: string
          description: >
            The unique identifier for the customer to whom the user will belong.
            May be the entity's internal UUID or an external reference
            identifier.

            Reference identifiers MUST be prefixed with `rid_` (e.g.,
            `rid_crm-customer-12345`) so the API

            can distinguish them from internal UUIDs. The prefix is stripped
            before lookup.
        referenceId:
          type: string
          description: >
            A reference identifier provided by API clients to identify this user
            in their

            own systems. Must be unique per tenant. Use this field to look up
            users by

            your external identifier.
          example: hr-employee-98765
          maxLength: 255
        identity:
          $ref: '#/components/schemas/Identity'
        metadata:
          $ref: '#/components/schemas/Metadata'
    User:
      type: object
      description: A user within the system.
      required:
        - userId
        - name
      properties:
        userId:
          type: string
          description: Unique identifier for the user.
        name:
          type: string
          description: Name of the user.
        email:
          type: string
          format: email
          description: Email of the user.
        msisdn:
          type: string
          format: phone
          description: Mobile phone number of the user.
        identity:
          $ref: '#/components/schemas/Identity'
        referenceId:
          type: string
          description: >
            A reference identifier provided by API clients to identify this user
            in their

            own systems. Must be unique per tenant. Use this field to look up
            users or

            to create/retrieve users during order creation.
          example: hr-employee-98765
          maxLength: 255
        customers:
          type: array
          items:
            $ref: '#/components/schemas/EmbeddedCustomer'
        createdAt:
          type: string
          format: date-time
          description: Date and time when the user was created.
        updatedAt:
          type: string
          format: date-time
          description: Date and time when the user was last updated.
        metadata:
          $ref: '#/components/schemas/Metadata'
    Identity:
      type: string
      description: >-
        The identity of the entity, such as personal number, organization
        number, etc., depending on the country, entity, and customer type.
    Metadata:
      type: object
      additionalProperties:
        type: string
      description: >
        A set of key-value pairs that can be attached to an object for storing
        additional information in a semi-structured format.
    EmbeddedCustomer:
      type: object
      description: >-
        Customer information embedded in responses. Sensitive details require
        separate API calls with appropriate authorization.
      required:
        - customerId
        - name
      properties:
        customerId:
          type: string
          description: The unique identifier for the customer.
        name:
          type: string
          description: The customer's display name.
    Error:
      type: object
      required:
        - message
        - code
      properties:
        message:
          type: string
          description: A human-readable message providing more details about the error.
        code:
          type: string
          description: A machine-readable code for the error.
        details:
          type: array
          description: Additional details about the error.
          items:
            type: object
            required:
              - message
              - code
            properties:
              message:
                type: string
                description: >-
                  A human-readable message providing more details about the
                  error.
              code:
                type: string
                description: A machine-readable code for the specific detail.
              property:
                type: string
                description: The property or field related to the error.
              suggestion:
                $ref: '#/components/schemas/Any'
                description: >
                  A suggested value for the particular property.


                  For example, this may be set when validating an address with
                  an alias, suggesting the expected value by the operator.
        hint:
          type: string
          description: A hint to help resolve the error.
    Any:
      oneOf:
        - type: string
        - type: number
        - type: boolean
        - type: object
          additionalProperties: true
        - type: array
  responses:
    BadRequest:
      description: The request was malformed or invalid.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Unauthorized:
      description: Authentication is required to access this resource.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Forbidden:
      description: Access to this resource is forbidden.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    Conflict:
      description: Conflict
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    TooManyRequests:
      description: Too many requests have been sent in a given amount of time.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
    InternalServerError:
      description: An unexpected error occurred on the server.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: X-Api-Key
      description: >
        An API key that grants access to the Connect API. You can create and
        manage API keys in the portal.
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >
        Bearer authentication with JWT tokens is used to authenticate users.


        Do note that a valid API keys is also required to access the Connect API
        to prove that requests are made by a trusted party.


        Requests with a JWT token is scoped to the permissions of the user the
        token belongs to, regardless of the API key used.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.